//
//  SceneDelegate.swift
//  SDKEmbedSample
//
//  Created by Илья on 13.11.2023.
//

import UIKit
import DSSFramework

class SceneDelegate: UIResponder, UIWindowSceneDelegate {

    var window: UIWindow?
    var currentVC: UIViewController?

    func scene(_ scene: UIScene, willConnectTo session: UISceneSession, options connectionOptions: UIScene.ConnectionOptions) {
        //...Ваша работа с UI
        
        DSSNavigation.shared.delegate = self
        DSSNavigation.shared.modalLoadingForSilentRequestType = .outer
    }

    //...Остальные методы SceneDelegate
}

extension SceneDelegate: DSSNavigationDelegate {
    func needShowLoading() { }

    func needHideLoading() { }

    func needShow(navigationController: DSSNavigationController,
        animated: Bool, completion: @escaping (() -> Void)) {
            
        guard let window = self.window else { return }
        self.currentVC = window.rootViewController

        window.rootViewController = navigationController

        if animated == true {
            let options: UIView.AnimationOptions = .transitionCrossDissolve
            UIView.transition(with: window, duration: 0.2, options: options,
                              animations: {}, completion: { completed in
                completion()
            })
        } else {
            completion()
        }
    }

    func needHide(navigationController: DSSNavigationController,
                  animated: Bool, completion: @escaping (() -> Void)) {
        
        guard let window = self.window else { return }
        guard let currentVC = self.currentVC else { return }
        window.rootViewController = currentVC

        if animated == true {
            let options: UIView.AnimationOptions = .transitionCrossDissolve
            UIView.transition(with: window, duration: 0.2, options: options,
                              animations: {}, completion: { completed in
                completion()
            })
        } else {
            completion()
        }
    }
}

