//
//  ViewController.swift
//  SDKEmbedSample
//
//  Created by Илья on 13.11.2023.
//

import UIKit
import DSSFramework

class ViewController: UIViewController {
    
    lazy var showSDKButton: UIButton = {
        let b: UIButton = .init(configuration: .filled())
        b.setTitle("Показать Demo DSS SDK", for: .normal)
        return b
    }()

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        view.backgroundColor = .systemBackground
        view.addSubview(showSDKButton)
        showSDKButton.centerInSuperview()
        showSDKButton.addTarget(self, action: #selector(showSDK), for: .touchUpInside)
        
        initSDK()
    }
    
    @objc func showSDK() {
        DSSDemoVC.show()
    }
    
    func initSDK() {
        DSSCryptoProDss.shared._init() { res in
            var message: String = "Инициализация DSS SDK"
            switch res {
            case .init_ok:
                //MARK:- Успешная инициализация
                message = "DSS SDK успешно инициализирован"
            case .init_lockScreen_not_installed:
                //MARK:- На устройстве не настроен экран блокировки
                print("DSS SDK инициализирован")
            case .init_certs_not_installed:
                //MARK:- Корневые сертификаты не установлены
                message = "Ошибка инициализации DSS SDK"
            case .init_device_rooted:
                //MARK:- Устройство имеет права суперпользователя
                message = "Ошибка инициализации DSS SDK"
            }
            print(message)
        }
    }


}

